// m:  
//  4.2  21.04.2014

function MainMech(canvas) {

    //  

    var context = canvas.getContext("2d");                  //  context  
    document.oncontextmenu=function(e){return false};       //   

    const Pi = 3.1415926;                   //  ""

    const m0 = 1;                           //  
    const T0 = 1;                           //   (   )
    const a0 = 1;                           //   ( )

    const g0 = a0 / T0 / T0;                //   (,    T0    a0)

    const k0 = 2 * Pi / T0;           	    //  
    const C0 = m0 * k0 * k0;          	    //  
    const B0 = 2 * m0 * k0;  	      	    //  

    // ***    ***

    const Ny = 5;						    //  ,      (     )
    const m = 1 * m0;                 	    // 
    const Cwall = 10 * C0;                 	//  
    const Cball = 0.1 * Cwall;              //   
    const B = 0.008 * B0;              	    //  
    const B1 = 0.03 * B0;              	    //   
    const mg = 0.25 * m * g0;          	    //  
    const r = 0.5 * a0;               	    //     
    const arCoeff = 0.75;                   //  r < arCoeff*a,      arCoeff*a
    const a = 2 * r;                        //    
    const aCut = 2 * a;                     //  

    // ***    ***

    const fps = 50;             	        // frames per second -     ( )
    const spf = 100;              		    // steps per frame   -      ( )
    const dt  = 0.045 * T0 / fps;      	    //   ( )

    //  

    const scale = canvas.height / Ny / a0;  //         
    const r2 = r*r;                         // ___  ___
    const aCut2 = aCut * aCut;              // ___  ___
    const a2 = a*a;                         // ___  ___
    const D = a2*Cball/72.0;                //    
    const LJCoeff = 12*D/a2;                //     -

    var w = canvas.width / scale;		    //     
    var h = canvas.height / scale;		    //     
    var xStart = 4 * r;	var yStart = h - r-3;	//   

    var dragAndDropBall = null;             //     

    //   

    var mouseX;     var mouseY;             //   
    var mx, my;                           //    (     )

    canvas.onmousedown = function(e){       //     
        refreshMouseCoords(e);              //     mouseX, mouseY
        //    ,   ,  ""
        // (..      )
        var mouseXX = mouseX/scale;     var mouseYY = mouseY/scale;
        for (var i = balls.length-1; i >= 0; i--){
            var b = balls[i];
            var rx = b.xx - mouseXX;
            var ry = b.yy - mouseYY;
            b.rLen2 = rx*rx + ry*ry;        //       
            if (b.rLen2 <= r2) {            //    
                if (e.which == 1) {         //    
                    dragAndDropBall = b;
                    dragAndDropBall.xPlus = dragAndDropBall.xx - mouseXX; //       x
                    dragAndDropBall.yPlus = dragAndDropBall.yy - mouseYY; //       y
                    mx = mouseXX;    my = mouseYY;
                    canvas.onmousemove = mouseMove;     //    -   
                } else if (e.which == 3) {              //    
                    balls.splice(i,1);                  //  
                }
                return;
            }
        }

        //     return   -    , ,    
        //        2r,     - r;
        if (mouseXX-r < 0 || mouseXX+r > w || mouseYY-r < 0 || mouseYY+r > h) return;
        for (var i0=0; i0<balls.length; i0++)
            if (balls[i0].rLen2 < 4*r2) return; //  rLen2  , ..     return
        if (e.which == 1) {
            dragAndDropBall = addNewBall(mouseX, mouseY);           //       
            dragAndDropBall.xPlus = 0;  dragAndDropBall.yPlus = 0;  //    
            mx = mouseXX;    my = mouseYY;
            canvas.onmousemove = mouseMove;     //    -   
        }
    };

    document.onmouseup = function(e){           //     
        canvas.onmousemove = null;              //    -   
        dragAndDropBall = null;                 //    -    
    };

    function mouseMove(e){                      //    ,     
        refreshMouseCoords(e);                  //     mouseX, mouseY
        var mouseXX = mouseX/scale;     var mouseYY = mouseY/scale;
        dragAndDropBall.xx = mouseXX + dragAndDropBall.xPlus;
        dragAndDropBall.yy = mouseYY + dragAndDropBall.yPlus;
        dragAndDropBall.x = dragAndDropBall.xx * scale;    		dragAndDropBall.y = dragAndDropBall.yy * scale;
        dragAndDropBall.vx = .6*(mouseXX-mx)/dt/fps;   dragAndDropBall.vy = .6*(mouseYY-my)/dt/fps;
        mx = mouseXX;    my = mouseYY;
    }

    function refreshMouseCoords(e){             //      mouseX  mouseY
        var rect = canvas.getBoundingClientRect();
        mouseX = e.clientX - rect.left;
        mouseY = e.clientY - rect.top;
    }

    //   

    var balls = [];                                 //  
    var addNewBall =  function(x, y){
        var b = [];

        b.x = x;               b.y = y;             //   
        b.xx = x / scale;      b.yy = y / scale;    //   
        b.fx = 0;              b.fy = mg;           // ,   
        b.vx = 0;              b.vy = 0;            // 

        balls[balls.length] = b;                    //     
        return b;
    };

    //   

    function control() {
        physics();
        draw();
    }

    //   

    function physics(){                             // ,     
        for (var s=1; s<=spf; s++) {

            //     , ..       
            for (var i0=0; i0<balls.length; i0++){
                balls[i0].fx = - B * balls[i0].vx; balls[i0].fy = mg - B * balls[i0].vy;
            }

            for (var i=0; i<balls.length; i++){
                //         ,
                //      
                for (var ii=i+1; ii < balls.length; ii++) {

                    var b1 = balls[i];      var b2 = balls[ii];             //   
                    var rx = b1.xx - b2.xx;   var ry = b1.yy - b2.yy;       //      (b1)
                    var r2 = rx*rx + ry*ry;                                 //    
                    if (r2 > aCut2) continue;                               //    
                    if (r2 < arCoeff*a2) r2 = arCoeff*a2;                   //    

                    var s2 = a2/r2;         var s4 = s2*s2;                 // ___  ___

                    var F = LJCoeff * s4 * s4 * (s4 * s2 - 1);              //   -
                    var Fx = F*rx;          var Fy = F*ry;

                    b1.fx += Fx;            b1.fy += Fy;
                    b2.fx -= Fx;            b2.fy -= Fy;
                }

                if (balls[i] == dragAndDropBall) continue;  //     -  .      

                if (balls[i].yy + r > h) { balls[i].fy += -Cwall * (balls[i].yy + r - h) - B1 * balls[i].vy; }
                if (balls[i].yy - r < 0) { balls[i].fy += -Cwall * (balls[i].yy - r) - B1 * balls[i].vy;}
                if (balls[i].xx + r > w) { balls[i].fx += -Cwall * (balls[i].xx + r - w) - B1 * balls[i].vx; }
                if (balls[i].xx - r < 0) { balls[i].fx += -Cwall * (balls[i].xx - r) - B1 * balls[i].vx; }

                balls[i].vx += balls[i].fx / m * dt;        balls[i].vy += balls[i].fy / m * dt;
                balls[i].xx += balls[i].vx * dt;    	    balls[i].yy += balls[i].vy * dt;

                balls[i].x = balls[i].xx * scale;    		balls[i].y = balls[i].yy * scale;
            }
        }
    }

    // 

    var rScale13 = r * scale*1.3;           // ___  ___
    var rScaleShift = r * scale/5.0;        // ___  ___
    function draw(){
        context.clearRect(0, 0, w*scale, h*scale);          //  
        for (var i = 0; i < balls.length; i++){
            var b = balls[i];

            //       
            var gradient=context.createRadialGradient(b.x, b.y, rScale13, b.x-rScaleShift, b.y+rScaleShift,0);
            gradient.addColorStop(0,"#0000bb");
            gradient.addColorStop(1,"#44ddff");
            context.fillStyle=gradient;

            context.beginPath();
            context.arc(b.x, b.y, r*scale,0,2*Math.PI);
            context.closePath();
            context.fill();
        }
    }

    //  

    addNewBall(xStart * scale, yStart * scale);
    setInterval(control, 1000/fps);

}